git-filter-branch.shon commit Make builtin-rerere use of strbuf nicer and more efficient. (8289b62)
   1#!/bin/sh
   2#
   3# Rewrite revision history
   4# Copyright (c) Petr Baudis, 2006
   5# Minimal changes to "port" it to core-git (c) Johannes Schindelin, 2007
   6#
   7# Lets you rewrite the revision history of the current branch, creating
   8# a new branch. You can specify a number of filters to modify the commits,
   9# files and trees.
  10
  11warn () {
  12        echo "$*" >&2
  13}
  14
  15map()
  16{
  17        # if it was not rewritten, take the original
  18        if test -r "$workdir/../map/$1"
  19        then
  20                cat "$workdir/../map/$1"
  21        else
  22                echo "$1"
  23        fi
  24}
  25
  26# if you run 'skip_commit "$@"' in a commit filter, it will print
  27# the (mapped) parents, effectively skipping the commit.
  28
  29skip_commit()
  30{
  31        shift;
  32        while [ -n "$1" ];
  33        do
  34                shift;
  35                map "$1";
  36                shift;
  37        done;
  38}
  39
  40# override die(): this version puts in an extra line break, so that
  41# the progress is still visible
  42
  43die()
  44{
  45        echo >&2
  46        echo "$*" >&2
  47        exit 1
  48}
  49
  50# When piped a commit, output a script to set the ident of either
  51# "author" or "committer
  52
  53set_ident () {
  54        lid="$(echo "$1" | tr "A-Z" "a-z")"
  55        uid="$(echo "$1" | tr "a-z" "A-Z")"
  56        pick_id_script='
  57                /^'$lid' /{
  58                        s/'\''/'\''\\'\'\''/g
  59                        h
  60                        s/^'$lid' \([^<]*\) <[^>]*> .*$/\1/
  61                        s/'\''/'\''\'\'\''/g
  62                        s/.*/export GIT_'$uid'_NAME='\''&'\''/p
  63
  64                        g
  65                        s/^'$lid' [^<]* <\([^>]*\)> .*$/\1/
  66                        s/'\''/'\''\'\'\''/g
  67                        s/.*/export GIT_'$uid'_EMAIL='\''&'\''/p
  68
  69                        g
  70                        s/^'$lid' [^<]* <[^>]*> \(.*\)$/\1/
  71                        s/'\''/'\''\'\'\''/g
  72                        s/.*/export GIT_'$uid'_DATE='\''&'\''/p
  73
  74                        q
  75                }
  76        '
  77
  78        LANG=C LC_ALL=C sed -ne "$pick_id_script"
  79        # Ensure non-empty id name.
  80        echo "[ -n \"\$GIT_${uid}_NAME\" ] || export GIT_${uid}_NAME=\"\${GIT_${uid}_EMAIL%%@*}\""
  81}
  82
  83# This script can be sourced by the commit filter to get the functions
  84test "a$SOURCE_FUNCTIONS" = a1 && return
  85this_script="$(cd "$(dirname "$0")"; pwd)"/$(basename "$0")
  86export this_script
  87
  88USAGE="[--env-filter <command>] [--tree-filter <command>] \
  89[--index-filter <command>] [--parent-filter <command>] \
  90[--msg-filter <command>] [--commit-filter <command>] \
  91[--tag-name-filter <command>] [--subdirectory-filter <directory>] \
  92[--original <namespace>] [-d <directory>] [-f | --force] \
  93[<rev-list options>...]"
  94
  95. git-sh-setup
  96
  97tempdir=.git-rewrite
  98filter_env=
  99filter_tree=
 100filter_index=
 101filter_parent=
 102filter_msg=cat
 103filter_commit='git commit-tree "$@"'
 104filter_tag_name=
 105filter_subdir=
 106orig_namespace=refs/original/
 107force=
 108while case "$#" in 0) usage;; esac
 109do
 110        case "$1" in
 111        --)
 112                shift
 113                break
 114                ;;
 115        --force|-f)
 116                shift
 117                force=t
 118                continue
 119                ;;
 120        -*)
 121                ;;
 122        *)
 123                break;
 124        esac
 125
 126        # all switches take one argument
 127        ARG="$1"
 128        case "$#" in 1) usage ;; esac
 129        shift
 130        OPTARG="$1"
 131        shift
 132
 133        case "$ARG" in
 134        -d)
 135                tempdir="$OPTARG"
 136                ;;
 137        --env-filter)
 138                filter_env="$OPTARG"
 139                ;;
 140        --tree-filter)
 141                filter_tree="$OPTARG"
 142                ;;
 143        --index-filter)
 144                filter_index="$OPTARG"
 145                ;;
 146        --parent-filter)
 147                filter_parent="$OPTARG"
 148                ;;
 149        --msg-filter)
 150                filter_msg="$OPTARG"
 151                ;;
 152        --commit-filter)
 153                filter_commit='SOURCE_FUNCTIONS=1 . "$this_script";'" $OPTARG"
 154                ;;
 155        --tag-name-filter)
 156                filter_tag_name="$OPTARG"
 157                ;;
 158        --subdirectory-filter)
 159                filter_subdir="$OPTARG"
 160                ;;
 161        --original)
 162                orig_namespace=$(expr "$OPTARG/" : '\(.*[^/]\)/*$')/
 163                ;;
 164        *)
 165                usage
 166                ;;
 167        esac
 168done
 169
 170case "$force" in
 171t)
 172        rm -rf "$tempdir"
 173;;
 174'')
 175        test -d "$tempdir" &&
 176                die "$tempdir already exists, please remove it"
 177esac
 178mkdir -p "$tempdir/t" &&
 179tempdir="$(cd "$tempdir"; pwd)" &&
 180cd "$tempdir/t" &&
 181workdir="$(pwd)" ||
 182die ""
 183
 184# Make sure refs/original is empty
 185git for-each-ref > "$tempdir"/backup-refs
 186while read sha1 type name
 187do
 188        case "$force,$name" in
 189        ,$orig_namespace*)
 190                die "Namespace $orig_namespace not empty"
 191        ;;
 192        t,$orig_namespace*)
 193                git update-ref -d "$name" $sha1
 194        ;;
 195        esac
 196done < "$tempdir"/backup-refs
 197
 198export GIT_DIR GIT_WORK_TREE=.
 199
 200# These refs should be updated if their heads were rewritten
 201
 202git rev-parse --revs-only --symbolic "$@" |
 203while read ref
 204do
 205        # normalize ref
 206        case "$ref" in
 207        HEAD)
 208                ref="$(git symbolic-ref "$ref")"
 209        ;;
 210        refs/*)
 211        ;;
 212        *)
 213                ref="$(git for-each-ref --format='%(refname)' |
 214                        grep /"$ref")"
 215        esac
 216
 217        git check-ref-format "$ref" && echo "$ref"
 218done > "$tempdir"/heads
 219
 220test -s "$tempdir"/heads ||
 221        die "Which ref do you want to rewrite?"
 222
 223export GIT_INDEX_FILE="$(pwd)/../index"
 224git read-tree || die "Could not seed the index"
 225
 226ret=0
 227
 228# map old->new commit ids for rewriting parents
 229mkdir ../map || die "Could not create map/ directory"
 230
 231case "$filter_subdir" in
 232"")
 233        git rev-list --reverse --topo-order --default HEAD \
 234                --parents "$@"
 235        ;;
 236*)
 237        git rev-list --reverse --topo-order --default HEAD \
 238                --parents --full-history "$@" -- "$filter_subdir"
 239esac > ../revs || die "Could not get the commits"
 240commits=$(wc -l <../revs | tr -d " ")
 241
 242test $commits -eq 0 && die "Found nothing to rewrite"
 243
 244# Rewrite the commits
 245
 246i=0
 247while read commit parents; do
 248        i=$(($i+1))
 249        printf "\rRewrite $commit ($i/$commits)"
 250
 251        case "$filter_subdir" in
 252        "")
 253                git read-tree -i -m $commit
 254                ;;
 255        *)
 256                git read-tree -i -m $commit:"$filter_subdir"
 257        esac || die "Could not initialize the index"
 258
 259        export GIT_COMMIT=$commit
 260        git cat-file commit "$commit" >../commit ||
 261                die "Cannot read commit $commit"
 262
 263        eval "$(set_ident AUTHOR <../commit)" ||
 264                die "setting author failed for commit $commit"
 265        eval "$(set_ident COMMITTER <../commit)" ||
 266                die "setting committer failed for commit $commit"
 267        eval "$filter_env" < /dev/null ||
 268                die "env filter failed: $filter_env"
 269
 270        if [ "$filter_tree" ]; then
 271                git checkout-index -f -u -a ||
 272                        die "Could not checkout the index"
 273                # files that $commit removed are now still in the working tree;
 274                # remove them, else they would be added again
 275                git ls-files -z --others | xargs -0 rm -f
 276                eval "$filter_tree" < /dev/null ||
 277                        die "tree filter failed: $filter_tree"
 278
 279                git diff-index -r $commit | cut -f 2- | tr '\n' '\0' | \
 280                        xargs -0 git update-index --add --replace --remove
 281                git ls-files -z --others | \
 282                        xargs -0 git update-index --add --replace --remove
 283        fi
 284
 285        eval "$filter_index" < /dev/null ||
 286                die "index filter failed: $filter_index"
 287
 288        parentstr=
 289        for parent in $parents; do
 290                for reparent in $(map "$parent"); do
 291                        parentstr="$parentstr -p $reparent"
 292                done
 293        done
 294        if [ "$filter_parent" ]; then
 295                parentstr="$(echo "$parentstr" | eval "$filter_parent")" ||
 296                                die "parent filter failed: $filter_parent"
 297        fi
 298
 299        sed -e '1,/^$/d' <../commit | \
 300                eval "$filter_msg" > ../message ||
 301                        die "msg filter failed: $filter_msg"
 302        sh -c "$filter_commit" "git commit-tree" \
 303                $(git write-tree) $parentstr < ../message > ../map/$commit
 304done <../revs
 305
 306# In case of a subdirectory filter, it is possible that a specified head
 307# is not in the set of rewritten commits, because it was pruned by the
 308# revision walker.  Fix it by mapping these heads to the next rewritten
 309# ancestor(s), i.e. the boundaries in the set of rewritten commits.
 310
 311# NEEDSWORK: we should sort the unmapped refs topologically first
 312while read ref
 313do
 314        sha1=$(git rev-parse "$ref"^0)
 315        test -f "$workdir"/../map/$sha1 && continue
 316        # Assign the boundarie(s) in the set of rewritten commits
 317        # as the replacement commit(s).
 318        # (This would look a bit nicer if --not --stdin worked.)
 319        for p in $( (cd "$workdir"/../map; ls | sed "s/^/^/") |
 320                git rev-list $ref --boundary --stdin |
 321                sed -n "s/^-//p")
 322        do
 323                map $p >> "$workdir"/../map/$sha1
 324        done
 325done < "$tempdir"/heads
 326
 327# Finally update the refs
 328
 329_x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
 330_x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
 331count=0
 332echo
 333while read ref
 334do
 335        # avoid rewriting a ref twice
 336        test -f "$orig_namespace$ref" && continue
 337
 338        sha1=$(git rev-parse "$ref"^0)
 339        rewritten=$(map $sha1)
 340
 341        test $sha1 = "$rewritten" &&
 342                warn "WARNING: Ref '$ref' is unchanged" &&
 343                continue
 344
 345        case "$rewritten" in
 346        '')
 347                echo "Ref '$ref' was deleted"
 348                git update-ref -m "filter-branch: delete" -d "$ref" $sha1 ||
 349                        die "Could not delete $ref"
 350        ;;
 351        $_x40)
 352                echo "Ref '$ref' was rewritten"
 353                git update-ref -m "filter-branch: rewrite" \
 354                                "$ref" $rewritten $sha1 ||
 355                        die "Could not rewrite $ref"
 356        ;;
 357        *)
 358                # NEEDSWORK: possibly add -Werror, making this an error
 359                warn "WARNING: '$ref' was rewritten into multiple commits:"
 360                warn "$rewritten"
 361                warn "WARNING: Ref '$ref' points to the first one now."
 362                rewritten=$(echo "$rewritten" | head -n 1)
 363                git update-ref -m "filter-branch: rewrite to first" \
 364                                "$ref" $rewritten $sha1 ||
 365                        die "Could not rewrite $ref"
 366        ;;
 367        esac
 368        git update-ref -m "filter-branch: backup" "$orig_namespace$ref" $sha1
 369        count=$(($count+1))
 370done < "$tempdir"/heads
 371
 372# TODO: This should possibly go, with the semantics that all positive given
 373#       refs are updated, and their original heads stored in refs/original/
 374# Filter tags
 375
 376if [ "$filter_tag_name" ]; then
 377        git for-each-ref --format='%(objectname) %(objecttype) %(refname)' refs/tags |
 378        while read sha1 type ref; do
 379                ref="${ref#refs/tags/}"
 380                # XXX: Rewrite tagged trees as well?
 381                if [ "$type" != "commit" -a "$type" != "tag" ]; then
 382                        continue;
 383                fi
 384
 385                if [ "$type" = "tag" ]; then
 386                        # Dereference to a commit
 387                        sha1t="$sha1"
 388                        sha1="$(git rev-parse "$sha1"^{commit} 2>/dev/null)" || continue
 389                fi
 390
 391                [ -f "../map/$sha1" ] || continue
 392                new_sha1="$(cat "../map/$sha1")"
 393                export GIT_COMMIT="$sha1"
 394                new_ref="$(echo "$ref" | eval "$filter_tag_name")" ||
 395                        die "tag name filter failed: $filter_tag_name"
 396
 397                echo "$ref -> $new_ref ($sha1 -> $new_sha1)"
 398
 399                if [ "$type" = "tag" ]; then
 400                        # Warn that we are not rewriting the tag object itself.
 401                        warn "unreferencing tag object $sha1t"
 402                fi
 403
 404                git update-ref "refs/tags/$new_ref" "$new_sha1" ||
 405                        die "Could not write tag $new_ref"
 406        done
 407fi
 408
 409cd ../..
 410rm -rf "$tempdir"
 411echo
 412test $count -gt 0 && echo "These refs were rewritten:"
 413git show-ref | grep ^"$orig_namespace"
 414
 415exit $ret